package HT.fx;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Scanner;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.ohj2.Mjonot;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import HT.fx.Pelaaja;
import HT.fx.Pelaajat;
import HT.fx.Karkelot;
import HT.fx.SailoException;


/**
 * @author joonatan tuomas
 * @version 31.1.2024
 *
 */
public class PadelMainGUIController {
    

    @FXML private VBox AutoVbox;

    @FXML private VBox IkaVbox;

    @FXML private VBox NimiVbox;

    @FXML private VBox RatingVbox;

    @FXML private VBox SapoVbox;
    
    @FXML void handleLisaamuokkaaottelu() {
         handleLisaaOttelu(null, "kanat");
    }

    @FXML void handleLisaapelaaja() {
        //LisaaTestiPelaajat();
        handleLisaaPelaaja(null, "kanat");
        //LisaaPelaaja();
        //Syotatiedot();
        lisaakentat();
        syotatiedot();
        
    }
    

    @FXML void handleTallenna() throws SailoException {
        karkelo.talleta();
    }
    
    @FXML void handleHaeTiedot() throws SailoException {
        //Lukija("/Users/joonatan/kurssit/ohj2/ht/src/Pelaajatiedot");
        
        karkelo.lueTiedostosta("/Users/joonatan/kurssit/ohj2/ht/src/Pelaajatiedot");
        int i = 0;
        while ( i<karkelo.getPelaajia()) {
            
            lisaakentat();
            i++;
            
        }
        syotatiedot();
        
    }
    
    @FXML private void lisaatekstikentta(VBox boksi) {
        TextField newField = new TextField();
        boksi.getChildren().add(newField);
    }
    
    
    



    //=======================
     
    /**
     * karkelon oma karkelo johon tallennetaan pelaajat ja ottelut.
     */
    private static Karkelot karkelo;
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaPelaaja(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                LisaaPelaajaGUIController.class.getResource("LisaaPelaajaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaOttelu(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                OtteluIkkunaGUIController.class.getResource("OtteluIkkunaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    
    /**
     * Lisää tarvittavat kentät kun pelaaja luodaan
     */
    public void lisaakentat() {
        lisaatekstikentta(NimiVbox);
        lisaatekstikentta(IkaVbox);
        lisaatekstikentta(RatingVbox);
        lisaatekstikentta(SapoVbox);
        lisaatekstikentta(AutoVbox);
    }
    
    /**
     * Syöttää tiedot tekstikenttiin
     */
    public void syotatiedot() {
        int i = 0;
        int j = 0;
        int k = 0;
        int m = 0;
        int n = 0;
        for (Node lapsi : NimiVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(karkelo.annaPelaaja(i).getNimi());
                i++;
            }
        }
        
        for (Node lapsi : IkaVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
                tf.setText(String.valueOf(karkelo.annaPelaaja(j).getIka()));
                j++;
            }
        }
        
        for (Node lapsi : RatingVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(String.valueOf(karkelo.annaPelaaja(n).getRating()));
                n++;
            }
        }
        
        for (Node lapsi : SapoVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(karkelo.annaPelaaja(k).getSahkoposti());
                k++;
            }
        }
        
        for (Node lapsi : AutoVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
                if(karkelo.annaPelaaja(m).getAuto()) {
                    tf.setText("Kyllä");
                    m++;
                }else {
                    tf.setText("Ei");
                    m++;
                }
            }
        }
    }
    
    
    /**
     * @param karkelo karkelo jota käytetään tässä käyttöliittymässä
     */
    public void setKarkelo(Karkelot karkelo) {
        PadelMainGUIController.karkelo = karkelo;
        //naytaJasen();
    }


    /*
    private void LisaaPelaaja() {
        Pelaaja uusi = new Pelaaja();
        uusi.rekisteroi();
        uusi.vastaaAkuAnkka();
        try {
            karkelo.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
        
        //hae(uusi.getTunnusNro());

    }
    */
    
    /**
     * rekisteröi ja lisää parametrina annetun uuden pelaajan
     * @param uusi pelaaja
     */
    public static void LisaaPelaaja(Pelaaja uusi) {
        
        uusi.rekisteroi();
        //uusi.vastaaAkuAnkka();
        try {
            karkelo.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
        
        //hae(uusi.getTunnusNro());

    }
    
    /**
     * rekisteröi ja lisää parametrina annetun uuden ottelun
     * @param uusi ottelu
     */
    public static void LisaaOttelu(Ottelu uusi) {
        
        uusi.rekisteroi();
        karkelo.lisaa(uusi);
    }
    
    /**
     * Lisää kahdeksan testipelaajaa
     */
    public static void LisaaTestiPelaajat() {
        Pelaaja uusi = new Pelaaja("Rasse", LocalDate.of(1999, 5, 13) , "Rasse@gmail.com", false);
        Pelaaja uusi2 = new Pelaaja("Tuomas", LocalDate.of(2001, 9, 14) , "Tuomas@gmail.com", false);
        Pelaaja uusi3 = new Pelaaja("Joonatan", LocalDate.of(1998, 2, 24) , "Joonatan@gmail.com", true);
        Pelaaja uusi4 = new Pelaaja("Pepe", LocalDate.of(1998, 5, 13) , "Pepe@gmail.com", true);
        Pelaaja uusi5 = new Pelaaja("Levy", LocalDate.of(1999, 5, 13) , "Levy@gmail.com", false);
        Pelaaja uusi6 = new Pelaaja("Robbe", LocalDate.of(1998, 3, 14) , "Robbe@gmail.com", true);
        Pelaaja uusi7 = new Pelaaja("Riku", LocalDate.of(1998, 2, 24) , "Riku@gmail.com", true);
        Pelaaja uusi8 = new Pelaaja("Tommi", LocalDate.of(1998, 5, 13) , "Tommi@gmail.com", true);
        
        LisaaPelaaja(uusi);
        LisaaPelaaja(uusi2);
        LisaaPelaaja(uusi3);
        LisaaPelaaja(uusi4);
        LisaaPelaaja(uusi5);
        LisaaPelaaja(uusi6);
        LisaaPelaaja(uusi7);
        LisaaPelaaja(uusi8);
        
        
        
        
    }

    /**
     * Palauttaa controllerin käyttämän karkelon jotta sitä voi käyttää muissa controllereissa
     * @return karkelo
     */
    public static Karkelot getKarkelo() {
        return karkelo;
    }

}